/*
 * IRC - Internet Relay Chat, ircd/ssl.c
 * Copyright (C) 2015 pk910 (Philipp Kreil)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/** @file
 * @brief Implementation of functions for handling ssl connections
 * @version $Id$
 */
#include "config.h"

#include "client.h"
#include "ssl.h"
#include "class.h"
#include "ircd.h"
#include "ircd_features.h"
#include "ircd_log.h"
#include "ircd_reply.h"
#include "list.h"
#include "msgq.h"
#include "numeric.h"
#include "s_conf.h"
#include "s_debug.h"
#include "send.h"
#include "struct.h"

/* #include <assert.h> -- Now using assert in ircd_log.h */
#include <string.h>

#ifndef IOV_MAX
#define IOV_MAX 16	/**< minimum required length of an iovec array */
#endif

#if defined(HAVE_GNUTLS)
#include "ssl.gnutls.c"
#elif defined(HAVE_OPENSSL)
#include "ssl.openssl.c"
#else
void ssl_free_connection(struct SSLConnection *connection) {}
void ssl_free_listener(struct SSLConnection *listener) {}
struct SSLListener *ssl_create_listener() { return NULL; }
struct SSLConnection *ssl_start_handshake_listener(struct SSLListener *listener, int fd, void *data, enum SSLDataType datatype) { return NULL; }
IOResult ssl_recv_decrypt(struct SSLConnection *connection, char *buf, int *len) { return IO_FAILURE; }
int ssl_connection_flush(struct SSLConnection *connection) { return 0; };
const char* ssl_get_cipher(struct SSLConnection *connection) { return NULL; }
#endif

